//
// TESquirtOption header
//
// Copyright (C) 1999-2001 Hewlett Packard
// By John Schettino, schettj@hpl.hp.com
//

// CVS info
/*
$Header: /home/cvs/Hack/Esquirt/Linux/compat/TESquirtOption.h,v 2.5 2001/05/09 21:30:39 jeant Exp $
*/
/*
$Log: TESquirtOption.h,v $
Revision 2.5  2001/05/09 21:30:39  jeant
Proper licensing terms (thanks to Mirjana)...

Revision 2.4.3.1  2001/02/16 23:57:34  jeant
Imported sources

*/
/*
Copyright (C) 1995-2001 Hewlett-Packard Company 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
*/


#ifndef __TESQUIRTOPTION__
#define __TESQUIRTOPTION__

// supported values

// Squirting, which means use hp:esquirt as
// either the IAS name (IRDA) and/or
// as the TARGET header value (OBEX) based on
// protocol and transport settings

#define ESQUIRT_SQUIRT		1

// Beaconing, which means use hp:beacon as either
// the IAS name (IRDA) and/or
// as the TARGET header value (OBEX)
// based on protocol and transport settings

#define ESQUIRT_BEACON		2 


// Send/receive using any/all available
// modes/transports/protocols

#define ESQUIRT_AUTO 		0  

#define ESQUIRT_ULTRA		1 // Send/receive using Ultra IR transport
#define ESQUIRT_IRDA		2 // Send/receive using IrDA TinyTp protocol -- may be OBEX or (ESquirt V1)
#define ESQUIRT_BLUETOOTH	4 // Send/receive using BlueTooth (not implemented, future support)
#define ESQUIRT_TCPIP		8 // Send/receive using TCP/IP (not implemented, future support)

#define ESQUIRT_RAW			1 // no Encode/decode content for GetCapabilities()
#define ESQUIRT_OBEX		2 // Encode/decode content using Obex / Supports PUT for GetCapabilities()
#define ESQUIRT_OBEX_GET	4 // Supports GET for GetCapabilities()

#define ESQUIRT_NONE		0xff

typedef struct _TESquirtOption {
	unsigned int mode;
	unsigned int transport;
	unsigned int protocol;
} TESquirtOption;

// define functions to manipulate a TCoolReference struct
#define TESquirtOption_Mode(a) (a.mode)
#define TESquirtOption_Transport(a) ((a).transport)
#define TESquirtOption_Protocol(a) ((a).protocol)

#endif

