/*
 *			    Squirt Ultra common
 *			    -------------------
 *
 *		Jean II '00
 *
 * Public header for squirt_ultra.c
 * Defines all you need to know about the file...
 *
 * This file is released under the GPL license.
 */

/*
 * CVS blurb
 * $Header: /home/cvs/Hack/Esquirt/Linux/squirt_ultra.h,v 2.6 2001/05/09 21:30:39 jeant Exp $
 * $Log: squirt_ultra.h,v $
 * Revision 2.6  2001/05/09 21:30:39  jeant
 * Proper licensing terms (thanks to Mirjana)...
 *
 * Revision 2.5  2001/04/19 18:56:25  jeant
 * Temporary release, not fully functional
 * Reworked native API
 * Got type/accept/target Obex headers working properly
 * Updated tests
 *
 * Revision 2.4.3.1  2001/02/16 23:57:34  jeant
 * Imported sources
 *
 */
/*
Copyright (C) 1995-2001 Hewlett-Packard Company 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
*/

#ifndef SQUIRT_ULTRA_H
#define SQUIRT_ULTRA_H

/***************************** INCLUDES *****************************/

#include "squirt_common.h"	/* For es_squirt, es_listen and co... */

/************************ CONSTANTS & MACROS ************************/

/*
 * This is the Ultra protocol ID we are currently using (7 bits)
 * Currently, IrDA-Ultra defines only UPID 0x1 for Obex. We use
 * this for e-Squirt over Obex over Ultra.
 * For e-Squirt directly over ultra, we use our own PID (0x3).
 * Please note that 0x2 conflict with IrWW (that's why we changed)
 */
#define UPID_OBEX		0x1		/* Official */
#define UPID_BEACON_OLD		0x2		/* To be changed */
#define UPID_BEACON		0x3		/* Much better */

/**************************** PROTOTYPES ****************************/

/* Send a squirt over Ultra */
int
	send_ultra(es_squirt *	content,
		   es_opt *	options,
		   es_trans *	extra);
/* Add a squirt listener over Ultra */
es_listen *
	add_ultra(es_listen *	list,
		  es_opt *	options,
		  int		upid);

#endif	SQUIRT_ULTRA_H
